/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("@agentframework/domain"),r=require("@agentframework/web"),o=require("url"),i=require("@agentframework/app"),n=require("@agentframework/data"),s=require("querystring"),a=require("node-fetch"),l=(e=a)&&"object"==typeof e&&"default"in e?e.default:e,d=require("lodash"),p=require("path"),c=require("crypto"),u=require("@agentframework/core"),g=require("protobufjs");function h(e,t,r,o){var i,n=arguments.length,s=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,r):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,o);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(s=(n<3?i(s):n>3?i(t,r,s):i(t,r))||s);return n>3&&s&&Object.defineProperty(t,r,s),s}function y(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}class WebFoundationController extends i.Resolvable{getFailureURL(e,t){return e.logger.error(t),"/#"+e.settings.WEB_SIGNIN_FAILED_PATH}}class WebFoundationService extends i.Resolvable{}let m=class ExternalUserModel extends n.Model{};h([n.property(),y("design:type",Object)],m.prototype,"uid",void 0),h([n.property(),y("design:type",String)],m.prototype,"provider",void 0),h([n.property(),y("design:type",String)],m.prototype,"providerProtocol",void 0),h([n.property(),y("design:type",String)],m.prototype,"providerURL",void 0),h([n.property(),y("design:type",String)],m.prototype,"providerId",void 0),h([n.property(),y("design:type",String)],m.prototype,"providerData",void 0),h([n.property(),y("design:type",String)],m.prototype,"userData",void 0),h([n.property(),y("design:type",Object)],m.prototype,"user",void 0),h([n.property(),y("design:type",String)],m.prototype,"domain",void 0),h([n.property(),y("design:type",Boolean)],m.prototype,"domainCertified",void 0),h([n.property(),y("design:type",Object)],m.prototype,"email",void 0),h([n.property(),y("design:type",Boolean)],m.prototype,"emailCertified",void 0),h([n.property(),y("design:type",Object)],m.prototype,"mobile",void 0),h([n.property(),y("design:type",Boolean)],m.prototype,"mobileCertified",void 0),h([n.property(),y("design:type",String)],m.prototype,"username",void 0),h([n.property(),y("design:type",String)],m.prototype,"displayName",void 0),h([n.property(),y("design:type",String)],m.prototype,"displayImageURL",void 0),h([n.property(),y("design:type",String)],m.prototype,"displayImageFile",void 0),h([n.property(),y("design:type",Object)],m.prototype,"familyName",void 0),h([n.property(),y("design:type",Object)],m.prototype,"givenName",void 0),h([n.property(),y("design:type",Object)],m.prototype,"gender",void 0),h([n.property(),y("design:type",Object)],m.prototype,"dob",void 0),h([n.property(),y("design:type",Object)],m.prototype,"status",void 0),h([n.property(),y("design:type",Object)],m.prototype,"bio",void 0),h([n.property(),y("design:type",Object)],m.prototype,"homepage",void 0),h([n.property(),y("design:type",Object)],m.prototype,"locale",void 0),m=h([n.model("external_user")],m);class ExternalUserCollection extends n.DocumentCollection{constructor(){super(m)}}let v=class ExternalTokenModel extends n.Model{};h([n.property(),y("design:type",String)],v.prototype,"token_type",void 0),h([n.property(),y("design:type",String)],v.prototype,"scope",void 0),h([n.property(),y("design:type",Number)],v.prototype,"expires_in",void 0),h([n.property(),y("design:type",String)],v.prototype,"access_token",void 0),h([n.property(),y("design:type",Object)],v.prototype,"id_token",void 0),v=h([n.model("external_token")],v);class ExternalTokenCollection extends n.DocumentCollection{constructor(){super(v)}}class ExternalUserService extends WebFoundationService{async updateToken(e,t,r){return(await e.resolve(ExternalTokenCollection)).replaceOne(r._id,t)}async connectUser(e,t,r){return(await e.resolve(ExternalUserCollection)).mergeOne(t._id,{user:r._id})}async findOrCreateExternalUser(e,t){const r=await e.resolve(ExternalUserCollection),o=i.CreateHashedObjectId([t.uid,t.providerId]);let n=await r.getOne(o);if(n)return n;n=new m,Object.assign(n,t);const s=await r.insertOne(o,n);if(!s)throw new Error("Unable to create external user");return s}async findOrCreateOrUpdateDifferenceExternalUser(e,t){const r=await e.resolve(ExternalUserCollection),o=i.CreateHashedObjectId([t.uid,t.providerId]);let n=await r.getOne(o),s=!1;if(n){for(const e of Object.keys(t))if(n[e]!=t[e]&&"object"!=typeof t[e]){s=!0;break}if(!s)return n}const a=n||new m;return Object.assign(a,t),s?r.mergeOne(o,a).then(e=>{if(!e)throw new Error("Unable to merge external user");return a}):r.insertOne(o,a).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}}let f=class UserModel extends n.Model{};f=h([n.model("user")],f);class UserCollection extends n.DocumentCollection{constructor(){super(f)}}let I,_=class EmailModel extends n.Model{};h([n.key(),y("design:type",String)],_.prototype,"name",void 0),h([n.property(),y("design:type",String)],_.prototype,"displayName",void 0),h([n.property(),y("design:type",String)],_.prototype,"user",void 0),h([n.property(),y("design:type",Boolean)],_.prototype,"verified",void 0),h([n.property(),y("design:type",Date)],_.prototype,"verifiedAt",void 0),h([n.property(),y("design:type",Object)],_.prototype,"verifiedBy",void 0),h([n.property(),y("design:type",String)],_.prototype,"verifiedFrom",void 0),h([n.property(),y("design:type",String)],_.prototype,"verifiedReason",void 0),h([n.property(),y("design:type",String)],_.prototype,"verifyToken",void 0),h([n.property(),y("design:type",Number)],_.prototype,"verifyTokenFailures",void 0),h([n.property(),y("design:type",Date)],_.prototype,"verifyTokenExpires",void 0),h([n.property(),y("design:type",Date)],_.prototype,"resetPasswordAt",void 0),h([n.property(),y("design:type",String)],_.prototype,"resetPasswordFrom",void 0),h([n.property(),y("design:type",Object)],_.prototype,"resetPasswordBy",void 0),h([n.property(),y("design:type",String)],_.prototype,"resetPasswordToken",void 0),h([n.property(),y("design:type",Number)],_.prototype,"resetPasswordTokenFailures",void 0),h([n.property(),y("design:type",Date)],_.prototype,"resetPasswordTokenExpires",void 0),_=h([n.model("email")],_);class EmailCollection extends n.DocumentCollection{constructor(){super(_)}}class UserService extends WebFoundationService{async findOneById(e,t){return(await e.resolve(UserCollection)).getOne(t)}async isEmailBeenUsed(e,t){const r=await e.resolve(EmailCollection),o=i.CreateHashedObjectId(t.trim().toLowerCase());return r.getOne(o).then(e=>!!e)}async isMobileExists(e,t){return!1}async findUserFromEmail(e,t){const r=await e.resolve(EmailCollection),o=i.CreateHashedObjectId(t.trim().toLowerCase()),n=await r.getOne(o);if(n&&n.user)return(await e.resolve(UserCollection)).getOne(new i.ObjectId(n.user))}async findOrCreateUserFromExternalUser(e,t){const r=await e.resolve(UserCollection),o=await e.resolve(EmailCollection),n=t._id,s=await r.getOne(n);if(s)return s;if(t.user){const e=await r.getOne(t.user);if(e)return e}const a={displayName:t.displayName,displayImageURL:t.displayImageURL||"",displayImageFile:t.displayImageFile||"",roles:["user"]};if(t.email&&t.emailCertified){const r=e.settings.ADMIN_EMAIL;r&&"string"==typeof r&&t.email===r&&a.roles.push("admin")}t.locale&&(a.locale=t.locale);const l=await r.insertOne(n,a);if(!l)throw new Error("Unable to create external user");if(t.email&&t.emailCertified){const r=i.CreateHashedObjectId(t.email.trim().toLowerCase()),n=new _;n.name=t.email,n.displayName=t.displayName,n.user=l._id.toHexString(),await o.insertOne(r,n)||e.logger.warn({user:l._id,email:n.name})}return l}}function b(e){return null!=e&&(I||(I=/^https?:\/\//i),I.test(e))}class ExternalFetcher{constructor(e){if(e&&e.baseURL&&!b(e.baseURL))throw new i.Exception({baseURL:e.baseURL},"Invalid fetch base url");this.defaults=e||{}}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),r=Object.assign({},this.defaults.headers,e.headers||{}),n=Object.assign({},e),l=n.headers=new a.Headers(r);let d;if(n.url&&b(n.url))d=new o.URL(n.url);else{if(!this.defaults.baseURL)throw new i.Exception({url:n.url},"Invalid fetch url");d=new o.URL(this.defaults.baseURL+n.url)}for(const e of Object.keys(t))d.searchParams.append(e,t[e]);if(n.data){const e=(l.get("content-type")||"").toString().toLowerCase();e.startsWith("application/json")?n.body=JSON.stringify(n.data):e.startsWith("application/x-www-form-urlencoded")?n.body=s.stringify(n.data):n.body=n.data,"string"==typeof n.body&&l.set("content-length",String(n.body.length))}return delete n.url,delete n.query,delete n.data,{url:d.toString(),init:n}}httpRequest(e){const{url:t,init:r}=this.makeFetchOptions(e);return l(t,r).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"application/octet-stream",body:new i.StreamReader(e.body)};return t.type.startsWith("application/json")&&(t.data=await t.body.json()),t})}httpPost(e,t,r={}){return r.method="POST",r.url=e,r.data=t,this.httpRequest(r)}httpPut(e,t,r={}){return r.method="PUT",r.url=e,r.data=t,this.httpRequest(r)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>e.body.text())}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>e.body.buffer())}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(null==e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OAuth2Client extends ExternalFetcher{constructor(e){super({headers:{Accept:"application/json","Content-Type":"application/json"}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:"code"};Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const r=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${s.stringify(r)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:"authorization_code"});return super.httpPost(this.options.token_endpoint,t,{headers:{"Content-Type":"application/x-www-form-urlencoded"}}).then(e=>{if(!e.data)throw new Error("InvalidOAuthTokenResponseType");return e.data}).catch(e=>(console.log("errror get token",e),console.log("try get token using json payload",t),super.httpPost(this.options.token_endpoint,t)))}get(e){return super.httpGetAsJson(e)}}class OpenIdAuthenticator extends WebFoundationService{update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),e.scope?this.scope=e.scope:this.scope="openid"}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:String(t)})}getSuccessURL(e){return"/#"+this.settings.WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return"/#"+this.settings.WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{if(e.id_token&&"string"==typeof e.id_token)try{const t=e.id_token.split("."),r=Buffer.from(t[1],"base64");e.id_token=JSON.parse(r.toString())}catch(t){e.id_token={},e.id_token_error=t.message}else e.id_token={},e.id_token_error="id_token is not found";return e})}async refreshToken(e){throw new Error("Not implemented refresh token")}async getUserProfile(e){const t=e.id_token;let r=[],o=null,i=null,n=null,s=!1;if(t.email&&(o=t.email,s=t.email_verified),o){const e=o.split("@");i=e[0],n=e[1]}return o&&s&&r.push({type:"email",value:o}),{uid:t.sub,providerData:null,identities:r,username:i,domain:n,email:o,emailCertified:s,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}}class CurrentUser extends f{static async[t.ClassInitializer](e){if(!(e instanceof r.WebRequest))throw new Error("CurrentUser is only resolvable from ctx scope");const t=e.identity.user;if(t&&i.ObjectId.isValid(t))return e.resolve(UserService).then(r=>r.findOneById(e,t).then(e=>{if(!e)throw new Error("NoCurrentUser");return Reflect.setPrototypeOf(e,CurrentUser.prototype),e}));throw new Error("NoCurrentUser")}}var C,S,x;class OpenIdController extends WebFoundationController{async getAuthenticator(e){const t=await this.discover(e),r=e.construct(OpenIdAuthenticator,[1,2,3]);return r.update({provider:t,issuer:t.providerURL,appID:t.appID,appSecret:t.appSecret,token_endpoint:t.providerConfiguration.token_endpoint,authorization_endpoint:t.providerConfiguration.authorization_endpoint,scope:t.scope}),r}OnProfile(e,t,r){return Promise.resolve(null)}async[C=Symbol("start")](e){let t;try{const r=await this.getAuthenticator(e),n=o.resolve(e.publicURL,"callback");n.startsWith("http://")&&e.logger.error("Unsecured oauth callback url: "+n),t=r.getAuthorizeURL(n,Date.now())}catch(r){t=await this.getFailureURL(e,new i.Exception(r,"Unable to start authentication"))}e.redirect(t)}async[S=Symbol("callback")](e){const t=await this.getAuthenticator(e),r=t.idProvider,n=o.resolve(e.publicURL,"callback");n.startsWith("http://")&&e.logger.error("Unsecured oauth callback url: "+n);const s=Number(e.query.state);if(s>Date.now()||s<Date.now()-e.settings.OIDC_AUTHENTICATION_EXPIRES_IN_MILLISECONDS)e.redirect(t.getFailureURL(new Error("Authentication Code Expired")));else{if(e.query.error){const r=new Error(`${e.query.error}: ${e.query.error_description}`);return e.logger.error(r,"Authentication Error"),void e.redirect(t.getFailureURL(r))}try{const o=e.query.code,s=await t.getToken(n,o);let a=await this.OnProfile(e,s,r).catch(()=>null);if(a||(a=await t.getUserProfile(s).catch(()=>null)),!a||!a.uid){let r=new Error("Unable to get unique user identity from provider");return e.logger.error(r),void e.redirect(t.getFailureURL(r))}a&&(Reflect.has(a,"user")&&(a.user&&i.ObjectId.isValid(a.user)?e.logger.warn(`External user ${a.uid}@${r._id} already set the user field to ${a.user}`):delete a.user),a.displayImageURL||e.logger.warn(`External user ${a.uid}@${r._id} do not have a profile image`),a.provider=r.provider,a.providerProtocol=r.providerProtocol,a.providerURL=r.providerURL,a.providerId=r._id.toString());const l=await this.ExternalUsers.findOrCreateOrUpdateDifferenceExternalUser(e,a);let d;await this.ExternalUsers.updateToken(e,s,l),d=l.user?await this.Users.findOneById(e,l.user):l.email&&l.emailCertified?await this.Users.findUserFromEmail(e,l.email):void 0;const p=await e.resolve(CurrentUser).catch(()=>void 0),c=await this.OnAuthenticated(e,r,s,l,d,p);e.redirect(t.getSuccessURL(c))}catch(r){e.logger.error(r,"Authentication Callback Error"),e.redirect(t.getFailureURL(r))}}}}h([t.singleton(),y("design:type",ExternalUserService)],OpenIdController.prototype,"ExternalUsers",void 0),h([t.singleton(),y("design:type",UserService)],OpenIdController.prototype,"Users",void 0),h([r.method("GET","/start"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],OpenIdController.prototype,C,null),h([r.method("GET","/callback"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],OpenIdController.prototype,S,null);class SessionService extends WebFoundationService{async ValidateSession(e){return!!(e.identity&&e.identity.token&&i.ObjectId.isValid(e.identity.token))&&!i.IsExpiredObjectId(new i.ObjectId(e.identity.token))}async CreateSession(e,t){const o=this.CreateNewSessionId(e),{token:i,expires:n}=this.CreateNewTokenId(e),s=Object.assign({},t,{session:o,token:i,expires:n});return e.construct(r.WebRequestIdentityService).setIdentityData(e,s),Promise.resolve(s)}async UpdateSession(e,t,o){if(e.identity.session===t){const t=e.construct(r.WebRequestIdentityService),{token:o,expires:i}=this.CreateNewTokenId(e);return t.setIdentityData(e,{session:e.identity.session,token:o,expires:i,profile:e.identity.profile}),!0}return!1}async ExtendSession(e,t){return this.UpdateSession(e,t,{})}async TerminateSession(e,t,o){if(e.identity.session===t){e.construct(r.WebRequestIdentityService).clearIdentityData(e);for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];return!0}return!1}CreateNewSessionId(e){return(new i.ObjectId).toHexString()}CreateNewTokenId(e){const t=new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS);return{token:new i.ObjectId(t).toHexString(),expires:t.getTime()}}}class AuthenticationService extends WebFoundationService{async IsAuthenticated(e){const t=await this.Sessions.ValidateSession(e);if(t&&e.identity.session&&e.identity.token){new i.ObjectId(e.identity.token).getTimestamp().getTime()-Date.now()<e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS-e.settings.WEB_TOKEN_EXPIRES_IN_MILLISECONDS&&await this.Refresh(e)}return t}async SignIn(e,t,r){const o=e.identity;if(e.state.new_device_id)throw new Error("Unable to authenticate without cookie support");o.session&&!i.IsExpiredObjectId(new i.ObjectId(o.token))&&(e.logger.debug({session:o.session},"Automatically logged out previous session for new user login"),await this.Sessions.TerminateSession(e,o.session,"SignIn"));const n={timezone:t.timezone,locale:t.locale,roles:r?d.intersection(t.roles||[],r):t.roles||[],groups:t.groups||[],profile:{_id:t._id.toString(),displayName:t.displayName,displayImageURL:t.displayImageURL}};return this.Sessions.CreateSession(e,n)}async Update(e,t){const r=t._id.toHexString();if(e.identity.user!==r)throw new Error("Unable to update signed in user to another user");return this.Sessions.UpdateSession(e,r,{user:r,profile:{_id:r,displayName:t.displayName,displayImageURL:t.displayImageURL}}).then(()=>!0).catch(()=>!1)}async Refresh(e){return!!e.identity.session&&this.Sessions.ExtendSession(e,e.identity.session).then(()=>!0).catch(()=>!1)}async SignOut(e,t="SignOut"){return!!e.identity.session&&this.Sessions.TerminateSession(e,e.identity.session,t)}}h([t.singleton(),y("design:type",SessionService)],AuthenticationService.prototype,"Sessions",void 0),function(e){e.SIGN_UP="sign-up",e.SIGN_UP_FAILED="sign-up-failed",e.SIGN_IN="sign-in",e.SIGN_IN_FAILED="sign-in-failed",e.SIGN_OUT="sign-out",e.SESSION_EXPIRED="session-expired",e.ACCESS_DENIED="access-denied"}(x||(x={}));let w=class EventModel extends n.Model{};h([n.property(),y("design:type",String)],w.prototype,"type",void 0),h([n.property(),y("design:type",Object)],w.prototype,"context",void 0),w=h([n.model("event")],w);class EventCollection extends n.DocumentCollection{constructor(){super(w)}}class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=p.join(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[t.ClassInitializer](e,t){return Reflect.construct(OpenIdConnect,t)}}let E=class ExternalProviderModel extends n.Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};h([n.property(),y("design:type",String)],E.prototype,"provider",void 0),h([n.property(),y("design:type",String)],E.prototype,"providerProtocol",void 0),h([n.property(),y("design:type",String)],E.prototype,"providerURL",void 0),h([n.property(),y("design:type",String)],E.prototype,"providerFingerprint",void 0),h([n.property(),y("design:type",Object)],E.prototype,"providerConfiguration",void 0),h([n.property(),y("design:type",String)],E.prototype,"appID",void 0),h([n.property(),y("design:type",String)],E.prototype,"appSecret",void 0),h([n.property(),y("design:type",String)],E.prototype,"scope",void 0),h([n.property(),y("design:type",String)],E.prototype,"displayName",void 0),h([n.property(),y("design:type",String)],E.prototype,"displayImageURL",void 0),h([n.property(),y("design:type",String)],E.prototype,"description",void 0),E=h([n.model("external_provider")],E);class ExternalProviderCollection extends n.DocumentCollection{constructor(){super(E)}}class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const r=this.createProviderId(t),o=await e.resolve(ExternalProviderCollection),i=await o.getOne(r);if(i){if(i.providerConfiguration)return i;if(i.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!i.providerConfiguration)throw new Error("Unable to discover external id provider");return o.mergeOne(r,i).then(e=>i)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return o.insertOne(r,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const t=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&t.push(String(e.appID)),i.CreateHashedObjectId(t)}async discoverProviderConfiguration(e,t){let r;try{r=new o.URL(t)}catch(e){throw new i.Exception(e,"Invalid external provider: "+t)}return"https:"!==r.protocol&&e.logger.warn("Unsecured external id provider: "+t),e.construct(OpenIdConnect).discovery(r).catch(t=>(e.logger.warn(t,{issuer:r},"Unable to discover the configuration"),null))}}class OpenIdAuthController extends OpenIdController{findOrResolveExternalProvider(e,t){return this.OpenIdProvider.findOrResolveExternalProvider(e,t)}async OnAuthenticated(e,t,o,i,n,s){if(n){const r=await this.WebAuth.SignIn(e.req,n);return r&&(e.logger.debug({user:n._id,email:i.email,roles:n.roles&&n.roles.join(","),session:r.session},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e,t,n)),n}if(i.email){if(await this.Users.isEmailBeenUsed(e,i.email))throw new r.AuthenticationError(`Email ${i.email} is already been used`)}const a=await this.Users.findOrCreateUserFromExternalUser(e,i);if(!a)throw new r.AuthenticationError({provider:t.provider,providerProtocol:t.providerProtocol,providerId:t._id},`Failed to register user ${i.uid}`);return await this.ExternalUsers.connectUser(e,i,a)||e.logger.error({external_user:i._id,new_created_user:a._id},"Unable to connect external user to new created user"),this.WebAuth.SignIn(e.req,a).then(r=>r?(e.logger.debug({user:a._id,email:i.email,roles:a.roles&&a.roles.join(","),session:r.session},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e,t,a).then(()=>a)):a)}async OnProfile(e,t,r){return this.OpenIdProfile.getProfile(e,t,r)}}h([t.singleton(),y("design:type",class EventService extends WebFoundationService{async getLatestEvents(e){return[]}async createSignInEvent(e,t,r){const o=x.SIGN_IN,n={provider:t.displayName,providerId:t._id,user:{_id:r._id,displayName:r.displayName,displayImageURL:r.displayImageURL}},s=await this.resolve(EventCollection),a=new w;return a.type=o,a.context=n,s.insertOne(i.CreateObjectId(),a)}async createSignUpEvent(e,t,r){const o=x.SIGN_UP,n={provider:t.displayName,providerId:t._id,user:{_id:r._id,displayName:r.displayName,displayImageURL:r.displayImageURL}},s=await e.resolve(EventCollection),a=new w;return a.type=o,a.context=n,s.insertOne(i.CreateObjectId(),a)}async createSignOutEvent(e,t){const r=x.SIGN_OUT,o={provider:t.displayName,providerId:t._id},n=await e.resolve(EventCollection),s=new w;return s.type=r,s.context=o,n.insertOne(i.CreateObjectId(),s)}})],OpenIdAuthController.prototype,"Events",void 0),h([t.singleton(),y("design:type",AuthenticationService)],OpenIdAuthController.prototype,"WebAuth",void 0),h([t.singleton(),y("design:type",ExternalProviderService)],OpenIdAuthController.prototype,"OpenIdProvider",void 0);class Weibo extends ExternalFetcher{constructor(e){if(super({baseURL:"https://api.weibo.com",query:{access_token:e}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e,t)}post(e,t,r){return super.httpPost(e,t,r)}comments(e={}){return this.get("/2/comments/to_me.json",e)}mentions(e={}){return this.get("/2/comments/mentions.json",e)}reposts(e={}){return this.get("/2/statuses/mentions.json",e)}weibo(e={}){return this.get("/2/statuses/home_timeline.json",e)}getLimits(){return this.get("/2/account/rate_limit_status.json",{})}}class OpenIdProfile{}exports.WeiboOpenIdAuthController=class WeiboOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_WEIBO)throw new Error("WeiboAuthIsNotEnabled");const t={provider:"weibo",providerProtocol:"oauth",providerURL:e.settings.OIDC_WEIBO_ISSUER_URL,displayName:"Weibo Account",displayImageURL:"https://www.weibo.com/favicon.ico",providerConfiguration:{issuer:e.settings.OIDC_WEIBO_ISSUER_URL,authorization_endpoint:"https://api.weibo.com/oauth2/authorize",token_endpoint:"https://api.weibo.com/oauth2/access_token",userinfo_endpoint:"https://api.weibo.com/2/users/show.json"}},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_WEIBO_CLIENT_ID,r.appSecret=e.settings.OIDC_WEIBO_CLIENT_SECRET,e.settings.OIDC_WEIBO_SCOPES&&(r.scope=e.settings.OIDC_WEIBO_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class WeiboProfileService extends OpenIdProfile{async getProfile(e,t,r){if(!r.providerConfiguration||!r.providerConfiguration.userinfo_endpoint)return null;const o=new Weibo(t.access_token),i=await o.post("https://api.weibo.com/oauth2/get_token_info",null);t.appkey=i.appkey;const n=await o.get(r.providerConfiguration.userinfo_endpoint,{query:{uid:t.uid}}).catch(e=>{throw console.log("unable to get weibot profile",e),e});return{uid:n.id,provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL,providerId:r._id.toHexString(),providerData:n,userData:{},identities:[],username:n.domain||null,domain:null,domainCertified:!1,email:null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.screen_name,displayImageURL:n.profile_image_url,familyName:null,givenName:null,gender:n.gender,dob:null,status:n.status?n.status.text:null,bio:n.description,homepage:n.url||null,locale:n.lang}}})],exports.WeiboOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.WeiboOpenIdAuthController=h([r.controller("/api/integration/weibo/auth")],exports.WeiboOpenIdAuthController);class BearerClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e)}post(e,t,r){return super.httpPost(e,t,r)}}exports.BitBucketOpenIdAuthController=class BitBucketOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_BITBUCKET)throw new Error("BitBucketAuthIsNotEnabled");const t={provider:"bitbucket",providerProtocol:"openid",providerURL:e.settings.OIDC_BITBUCKET_ISSUER_URL,displayName:"BitBucket Account",displayImageURL:"https://bitbucket.org/favicon.ico",providerConfiguration:{issuer:e.settings.OIDC_BITBUCKET_ISSUER_URL,authorization_endpoint:"https://bitbucket.org/site/oauth2/authorize",token_endpoint:"https://bitbucket.org/site/oauth2/access_token",userinfo_endpoint:"https://api.bitbucket.org/2.0/user"}},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_BITBUCKET_CLIENT_ID,r.appSecret=e.settings.OIDC_BITBUCKET_CLIENT_SECRET,e.settings.OIDC_BITBUCKET_SCOPES&&(r.scope=r.scope||e.settings.OIDC_BITBUCKET_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class BitBucketProfileService extends OpenIdProfile{async getProfile(e,t,r){const o=new BearerClient(t.access_token),i=await o.get(r.providerConfiguration.userinfo_endpoint),n=await o.get("https://api.bitbucket.org/2.0/user/emails");let s="",a=!1;const l=[];if(n&&n.values)for(const e of n.values)"email"===e.type&&e.is_primary&&(s=e.email,a=e.is_confirmed);return s&&a&&l.push({type:"email",value:s}),{uid:i.account_id,provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL,providerId:r._id.toHexString(),providerData:i,userData:{},identities:l,username:i.nickname,domain:"",domainCertified:!1,email:s,emailCertified:a,mobile:"",mobileCertified:!1,displayName:i.display_name,displayImageURL:"",familyName:"",givenName:"",gender:null,dob:null,status:null,bio:"",homepage:i.website,locale:""}}})],exports.BitBucketOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.BitBucketOpenIdAuthController=h([r.controller("/api/integration/bitbucket/auth")],exports.BitBucketOpenIdAuthController);exports.GoogleOpenIdAuthController=class GoogleOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GOOGLE)throw new Error("GoogleAuthIsNotEnabled");const t={provider:"google",providerProtocol:"openid",providerURL:e.settings.OIDC_GOOGLE_ISSUER_URL,displayName:"Google Account",displayImageURL:"https://www.google.com/favicon.ico"},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_GOOGLE_CLIENT_ID,r.appSecret=e.settings.OIDC_GOOGLE_CLIENT_SECRET,e.settings.OIDC_GOOGLE_SCOPES&&(r.scope=r.scope||e.settings.OIDC_GOOGLE_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class GoogleProfileService extends OpenIdProfile{constructor(){super(...arguments),this.TrustedEmailDomains=["gmail.com"]}async getProfile(e,t,r){const o=t.id_token;if(!r.providerConfiguration||!r.providerConfiguration.userinfo_endpoint)return null;const i=new BearerClient(t.access_token),n=await i.get(r.providerConfiguration.userinfo_endpoint).catch(()=>null);let s=[],a=null,l=null,d=null,p=!1;if(o.picture?d=o.picture:n&&n.picture&&(d=n.picture),o.email&&(a=o.email),a){const e=a.split("@");l=e[0],this.TrustedEmailDomains.indexOf(e[1].toLowerCase())>=0&&(p=o.email_verified)}return a&&p&&s.push({type:"email",value:a}),{uid:o.sub,provider:r.provider,providerProtocol:r.providerProtocol,providerId:r._id,providerData:n,userData:{},identities:s,username:l,domain:null,domainCertified:!1,email:a,emailCertified:p,mobile:null,mobileCertified:!1,displayName:o.name,displayImageURL:d,familyName:o.family_name,givenName:o.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:o.locale}}})],exports.GoogleOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GoogleOpenIdAuthController=h([r.controller("/api/integration/google/auth")],exports.GoogleOpenIdAuthController);exports.GitLabOpenIdAuthController=class GitLabOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GITLAB)throw new Error("GitLabAuthIsNotEnabled");const t={provider:"gitlab",providerProtocol:"openid",providerURL:e.settings.OIDC_GITLAB_ISSUER_URL,displayName:"GitLab Account",displayImageURL:"https://about.gitlab.com/ico/favicon-192x192.png"},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_GITLAB_CLIENT_ID,r.appSecret=e.settings.OIDC_GITLAB_CLIENT_SECRET,e.settings.OIDC_GITLAB_SCOPES&&(r.scope=r.scope||e.settings.OIDC_GITLAB_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class GitLabProfileService extends OpenIdProfile{async getProfile(e,t,r){const o=t.id_token;if(!r.providerConfiguration||!r.providerConfiguration.userinfo_endpoint)return null;const i=new BearerClient(t.access_token),n=await i.get(r.providerConfiguration.userinfo_endpoint);let s=[],a=n.picture;return n.email&&n.email_verified&&s.push({type:"email",value:n.email}),{uid:o.sub,provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL,providerId:r._id.toHexString(),providerData:n,userData:{},identities:s,username:n.nickname||null,domain:null,domainCertified:!1,email:n.email||null,emailCertified:n.email_verified||!1,mobile:null,mobileCertified:!1,displayName:o.name||n.name,displayImageURL:a,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:n.profile||null,locale:null}}})],exports.GitLabOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GitLabOpenIdAuthController=h([r.controller("/api/integration/gitlab/auth")],exports.GitLabOpenIdAuthController);exports.GitHubOpenIdAuthController=class GitHubOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_GITHUB)throw new Error("GitHubAuthIsNotEnabled");const t={provider:"github",providerProtocol:"oauth",providerURL:e.settings.OIDC_GITHUB_ISSUER_URL,displayName:"GitHub Account",displayImageURL:"https://github.com/favicon.ico",providerConfiguration:{issuer:e.settings.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:"https://github.com/login/oauth/authorize",token_endpoint:"https://github.com/login/oauth/access_token",userinfo_endpoint:"https://api.github.com/user"}},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_GITHUB_CLIENT_ID,r.appSecret=r.appSecret||e.settings.OIDC_GITHUB_CLIENT_SECRET,e.settings.OIDC_GITHUB_SCOPES&&(r.scope=r.scope||e.settings.OIDC_GITHUB_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class GitHubProfileService extends OpenIdProfile{async getProfile(e,t,r){const o=new BearerClient(t.access_token),i=t.id_token;if(!r.providerConfiguration||!r.providerConfiguration.userinfo_endpoint)return null;const n=await o.get(r.providerConfiguration.userinfo_endpoint),s=await o.get("https://api.github.com/user/emails").then(e=>[]);let a=n.id,l=null,d=n.avatar_url,p=[];if(s&&s.length)for(const e of s)e.email&&e.primary&&e.verified&&(l=e.email,p.push({type:"email",value:e.email}));return{uid:a,provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL,providerId:r._id.toHexString(),providerData:n,userData:{},identities:p,username:n.login,domain:null,domainCertified:!1,email:l,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.name||n.login,displayImageURL:d,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:n.bio||null,homepage:n.blog||n.html_url||null,locale:i.locale}}})],exports.GitHubOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GitHubOpenIdAuthController=h([r.controller("/api/integration/github/auth")],exports.GitHubOpenIdAuthController);class MicrosoftGraphClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}profile(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me")}photo(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me/photo").catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw new i.Exception(e,e.response.data,"Unable to resolve user photo")})}photoImage(e){return e?this.httpGetAsBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.httpGetAsBuffer("https://graph.microsoft.com/v1.0/me/photo/$value")}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e["@odata.mediaContentType"],r=e.id;return this.photoImage(r).then(e=>`data:${t};charset=utf-8;base64,${e.toString("base64")}`)})}users(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/users")}getNextUsers(e){return this.httpGetAsJson(e)}}let O=class FileModel extends n.Model{};h([n.property(),y("design:type",String)],O.prototype,"type",void 0),h([n.property(),y("design:type",Number)],O.prototype,"byteLength",void 0),h([n.property(),y("design:type",Buffer)],O.prototype,"data",void 0),h([n.property(),y("design:type",Number)],O.prototype,"width",void 0),h([n.property(),y("design:type",Number)],O.prototype,"height",void 0),h([n.property(),y("design:type",Number)],O.prototype,"duration",void 0),h([n.property(),y("design:type",String)],O.prototype,"ipfs",void 0),O=h([n.model("file")],O);class FileCollection extends n.BlobCollection{constructor(){super(O)}}let T=class FileTokenModel extends n.Model{};h([n.property(),y("design:type",String)],T.prototype,"file",void 0),h([n.property(),y("design:type",String)],T.prototype,"type",void 0),h([n.property(),y("design:type",Number)],T.prototype,"byteLength",void 0),h([n.property(),y("design:type",String)],T.prototype,"title",void 0),h([n.property(),y("design:type",String)],T.prototype,"originalname",void 0),h([n.property(),y("design:type",String)],T.prototype,"originalurl",void 0),T=h([n.model("file_token")],T);class FileTokenCollection extends n.DocumentCollection{constructor(){super(T)}}class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).getOne(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,r){return(await e.resolve(FileTokenCollection)).mergeOne(t,{title:r.title})}async insertFromURL(e,t,r){const o=await function(e){return l(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),i=t.split("/"),n=i[i.length-1];return this.insertFromBuffer(e,o.data,Object.assign({},r,{originalname:n,originalurl:t,type:o.dataType}))}async insertFromBuffer(e,t,r){let{type:o}=r;const n=c.createHash("sha256").update(t).digest(),s=require("multihashes").encode(n,"sha2-256"),a=i.Base58.fromBuffer(s),l=await e.resolve(FileCollection),d=await e.resolve(FileTokenCollection),p=await l.get(a),u=(new i.ObjectId).toString();if(p){o=p.type;const e={file:a,type:p.type,byteLength:p.byteLength};r&&(e.title=r.title,e.originalname=r.originalname,e.originalurl=r.originalurl),await d.insertOne(u,e)}else{const e={type:o=o||"application/octet-stream",byteLength:t.byteLength,data:t};if(r&&(e.width=r.width,e.height=r.height,e.duration=r.duration,e.ipfs=r.ipfs),!await l.add(a,e))throw new Error("UnableToSaveDataChunk");const i={file:a,type:o,byteLength:t.byteLength};r&&(i.title=r.title,i.originalname=r.originalname,i.originalurl=r.originalurl),await d.insertOne(u,i)}return Object.assign({id:u,type:o,byteLength:t.byteLength,url:"/api/file/token/"+u},r)}}exports.MicrosoftOpenIdAuthController=class MicrosoftOpenIdAuthController extends OpenIdAuthController{async discover(e){if(!e.settings.OIDC_MICROSOFT)throw new Error("MicrosoftAuthIsNotEnabled");const t={provider:"microsoft",providerProtocol:"openid",providerURL:e.settings.OIDC_MICROSOFT_ISSUER_URL,displayName:"Microsoft Account",displayImageURL:"https://www.microsoft.com/favicon.ico"},r=await this.findOrResolveExternalProvider(e,t);return r.appID=r.appID||e.settings.OIDC_MICROSOFT_CLIENT_ID,r.appSecret=e.settings.OIDC_MICROSOFT_CLIENT_SECRET,e.settings.OIDC_MICROSOFT_SCOPES&&(r.scope=r.scope||e.settings.OIDC_MICROSOFT_SCOPES.join(" ")),r}},h([t.singleton(),y("design:type",class MicrosoftProfileService extends OpenIdProfile{constructor(){super(...arguments),this.TrustedMicrosoftEmailDomains=["outlook.com","hotmail.com","live.cn","live.com","msn.com","passport.com","passport.net"]}async getProfile(e,t,r){const o=t.id_token;if(!r.providerConfiguration||!r.providerConfiguration.userinfo_endpoint)return console.log("provider not"),null;const i=new MicrosoftGraphClient(t.access_token),n=await i.profile().catch(()=>null);let s=null;const a=await i.photo();if(a){const t=await i.photoImage(a.id);if(t){const r=await e.resolve(WebFileService),o=await r.insertFromBuffer(e,t,{type:a["@odata.mediaContentType"],width:a.width,height:a.height}).catch(e=>(console.log("err",e),console.log(`Unable to save profile image for microsoft user ${a.id}, displayImageURL will be NULL`),null));o&&o.url&&(s=o.url)}}let l=null,d=null,p=null,c=null,u=[],g=null,h=!1;if(n?(l=n.id,d=n.displayName):(l=o.oid||o.sub,d=o.name),o.preferred_username?p=o.preferred_username:n&&n.userPrincipalName&&(p=n.userPrincipalName),p){const e=p.split("@");2===e.length&&(c=e[1].toLowerCase())}if(o.email?g=o.email:n&&n.mail&&(g=n.mail),g){const t=g.split("@");if(2===t.length){this.TrustedMicrosoftEmailDomains.indexOf(t[1].toLowerCase())>=0&&(h=!0);for(const o of e.settings.TRUSTED_EMAIL_PROVIDERS||[])if(("microsoft"===o.provider||o.provider===r.providerURL)&&o.domains.indexOf(t[1].toLowerCase())>=0){h=!0;break}}}return g&&h&&u.push({type:"email",value:g}),{uid:l,provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL,providerId:r._id.toHexString(),providerData:n,userData:{},identities:u,username:p,domain:c,domainCertified:!1,email:g,emailCertified:h,mobile:n&&n.mobilePhone,mobileCertified:!1,displayName:d,displayImageURL:s,familyName:n&&n.surname,givenName:n&&n.givenName,gender:null,dob:null,status:null,bio:n&&n.jobTitle,homepage:null,locale:n&&n.preferredLanguage}}})],exports.MicrosoftOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.MicrosoftOpenIdAuthController=h([r.controller("/api/integration/microsoft/auth")],exports.MicrosoftOpenIdAuthController),exports.WebFileController=class WebFileController{async token(e){const t=await this.WebFile.findTokenById(e,e.params.id);if(!t)throw new r.NotFoundError;const o=i.Base58.fromBuffer(i.CreateHashedObjectId(t.file).id),n=e.headers.get("if-none-match");if(n&&n===o)e.body=null,e.status=304;else{const i=await this.WebFile.findFileById(e,t.file);if(!i)throw new r.NotFoundError;e.body=i.data,e.setHeader("etag",o),e.setHeader("content-type",i.type),e.setHeader("content-length",`${i.byteLength}`),e.status=200}}},h([t.singleton(),y("design:type",WebFileService)],exports.WebFileController.prototype,"WebFile",void 0),h([r.method("GET","/token/:id"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],exports.WebFileController.prototype,"token",null),exports.WebFileController=h([r.controller("/api/file")],exports.WebFileController);class DialogAttribute{constructor(e){this._name=e}beforeDecorate(e,t,r){return!0}get name(){return this._name}}const B=new WeakMap;function R(e){return B.get(e)}function U(e,t){B.set(e,t)}class TypeRouterBindings extends i.Sequence{}class BotDialogRouter extends r.WebRouter{constructor(){super(...arguments),this._dialogs=[],this._root=new i.Route}search(e){const t=this._root.search(e);if(t&&t.node&&t.node.data)return{data:t.node.data,params:t.params}}add(e,t){const o=u.Reflector(e),i=o.getAttributes(r.ControllerAttribute),n=new Set;if(!i.length)throw new TypeError(`No @controller() attribute found on type ${e.prototype.constructor.name}`);for(const s of i){const i=s.path,a=this.createMiddleware(e),l=a.methods;for(const e of o.types())for(const o of e.properties()){const e=o.targetKey,d=e.toString();if(n.has(e))throw new TypeError(`Unable to override route for ${d}`);const p=l.length;let c=!1;const u=o.value.getAttributes(r.MiddlewareAttribute);for(const e of u)t&&t.beforeMiddleware&&!t.beforeMiddleware(s,e,o)||(this.addMiddleware(a,o,p),c=!0);for(const e of o.value.getAttributes(DialogAttribute)){const r=e.name?i+e.name:i||"",n=this._root.node(r);t&&t.beforeDialog&&!t.beforeDialog(s,e,o)||(this.addDialog(a,o,n,p),c=!0)}c&&(n.add(e),l.push(e))}l.length&&this._dialogs.push(a)}return this}createMiddleware(e){const t=new TypeRouterBindings;return t.performance=i.Performance,t.dataOf=R,t.type=e,t.methods=[],t.push(this.generateInitializerFn(t)),t}addMiddleware(e,t,r){e.push(this.generateMiddlewareFn(e,t,r))}addDialog(e,t,r,o){r.data.steps=r.data.steps||[],r.data.steps.push(this.generateDialogFn(e,t,o))}makeInvokeMethod(e,t){return"string"==typeof e?`.${e}`:"number"==typeof e?`[${e}]`:`[this.methods[${t}]]`}generateInitializerFn(e){return Function("ctx","next","if (!this.instance) {\n  this.performance.log(ctx, 'dialog', '[[new ' + this.type.prototype.constructor.name + '()]]');\n  this.instance = ctx.construct(this.type, true);\n}\nreturn next();").bind(e)}generateMiddlewareFn(e,t,r){const o=t.targetKey.toString(),i=this.makeInvokeMethod(t.targetKey,r);let n;return n=t.descriptor&&t.descriptor.value.length>2?`return this.performance.log(btx,'dialog','[${o}]'),this.instance${i}(btx, this.dataOf(btx), next);`:`return this.performance.log(btx,'dialog','[${o}]'),this.instance${i}(btx, next);`,Function("btx","next",n).bind(e)}generateDialogFn(e,t,r){const o=t.targetKey.toString(),i=this.makeInvokeMethod(t.targetKey,r);let n;n=t.descriptor&&t.descriptor.value.length>1?`return this.performance.log(btx,'dialog','${o}()'),this.instance${i}(btx, this.dataOf(btx));`:`return this.performance.log(btx,'dialog','${o}()'),this.instance${i}(btx);`;let s="";return s=e.length?"return btx.params=params,this.compose(btx, (btx)=>{\n"+`  ${n}\n`+"});":n,Function("btx","params",s).bind(e)}}class BotService extends i.Resolvable{}class DialogAction{}class DialogRouteAction extends DialogAction{constructor(e){super(),this.data=e}}class DialogResponseAction extends DialogAction{}class StartDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class ReplaceDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class RestartDialog extends DialogRouteAction{constructor(e){super(e)}}class EndDialog extends DialogRouteAction{constructor(e){super(e)}}class EndConversation extends DialogRouteAction{constructor(e){super(e)}}class ResetBot extends DialogRouteAction{constructor(e){super(e)}}class TextResponse extends DialogResponseAction{constructor(e,t){super(),this.text=e,this.format=t}}class DataResponse extends DialogResponseAction{constructor(e){super(),this.data=e}}class BotContext extends i.Container{sendText(e,t){throw new i.NotSupportedException("sendText")}replyText(e,t){throw new i.NotSupportedException("replyText")}startDialog(e,t){return new StartDialog(e,t)}replaceDialog(e,t){return new ReplaceDialog(e,t)}restartDialog(e){return new ReplaceDialog(this.path,e)}endDialog(e){return new EndDialog(e)}endConversation(e){return new EndConversation(e)}resetBot(e){return new ResetBot(e)}}class DialogError extends i.Exception{}async function A(e,t){let o=e.path,n=e.pathIndex;i.Performance.log(e,"router","[[LookupDialog]]"),e.logger.info(`[${e.identity.address}] --\x3e BOT ${o}[${n}]: ${e.message.text||"<redirect>"}`);const s=e.construct(BotDialogRouter).search(o);if(!(s&&s.data&&s.data.steps&&s.data.steps.length)){if(o.startsWith("/event/"))return console.log(`WARN: ${o} not found, end dialog and pop`),new EndDialog(R(e));throw new r.NotFoundError({path:o},"DialogNotFound")}const a=s.data.steps,l=a[n];if(!l)return console.log("WARN: path index not found, end dialog and pop"),new EndDialog(R(e));const d=!!a[n+1];return l(e,s.params).then(e=>d?e instanceof DialogResponseAction?e:e instanceof DialogRouteAction?e:"string"==typeof e?new TextResponse(e):new DataResponse(e):e instanceof DialogRouteAction?e:new EndDialog(e),e=>Promise.reject(new DialogError(e,e.message)))}const D=[];class BotStateService extends BotService{onCreate(){Reflect.apply(this.load,this,arguments)}load(...e){this.history=D,console.log("loading bot state from memory......")}async save(){console.log("saving bot state to memory......")}empty(){return!this.history.length}start(e){this.history.push([e,0,!0])}end(){for(let e=this.history.length-1;e>=0;e--){if(this.history[e][2])return void this.history.splice(e,this.history.length-e)}}isEnd(){const e=this.last();return!e||!!e[2]}push(e,t){this.history.push([e,0,t])}pop(){return this.history.pop()}last(){return this.history[this.history.length-1]}next(){const e=this.last();return e&&(e[1]=e[1]+1),e}restart(){const e=this.last();e&&(e[1]=0)}clear(){this.history.splice(0,this.history.length)}}async function k(e,t){let r,o;i.Performance.log(e,"router","[[LoadState]]");const n=await e.resolve(BotStateService);if(e.path)r=e.path,o=e.pathIndex,n.push(r);else{const e=n.last();e?(r=e[0],o=e[1]):(r="/",o=0)}return e.path=r||"/",e.pathIndex=o||0,t().then(e=>{if(e instanceof DialogRouteAction)if(e instanceof EndDialog){const t=n.isEnd();if(n.pop(),t)return new TextResponse(e.data)}else if(e instanceof StartDialog)n.next(),n.push(p.resolve(r,e.path));else if(e instanceof ReplaceDialog)n.pop(),n.push(p.resolve(r,e.path));else{if(!(e instanceof RestartDialog))return e instanceof ResetBot?(n.clear(),new TextResponse("ResetBot")):(n.pop(),n.end(),new TextResponse("EndConversation"));n.restart()}else n.next();return e})}class TelegramClient extends ExternalFetcher{constructor(e){if("string"!=typeof e&&!e)throw new Error("apiKey can not be null or empty");super({baseURL:`https://api.telegram.org/bot${e}`,headers:{"Content-Type":"application/json"}})}static[t.ClassInitializer](e,t){return Reflect.construct(TelegramClient,t)}getMe(){return this.post("/getMe")}getUserProfilePhotos(e){const t={user_id:String(e)};return this.post(`/getUserProfilePhotos?${s.stringify(t)}`)}getFile(e){const t={file_id:e};return this.post(`/getFile?${s.stringify(t)}`)}sendMessage(e,t,r){return this.post("/sendMessage",Object.assign({chat_id:e,text:t,parse_mode:"html",disable_web_page_preview:!0},r))}editMessageText(e,t,r,o){return this.post("/editMessageText",Object.assign({chat_id:e,message_id:t,text:r,parse_mode:"html"},o))}editMessageReplyMarkup(e,t,r){return this.post("/editMessageReplyMarkup",Object.assign({chat_id:e,message_id:t},r))}forwardMessage(e,t,r){return this.post("/forwardMessage",{chat_id:e,from_chat_id:t,message_id:r})}answerCallbackQuery(e,t,r,o){return this.post("/answerCallbackQuery",{callback_query_id:e,text:t,show_alert:r,url:o})}setWebhook(e,t,r,o){return this.post("/setWebhook",{url:e,certificate:t,max_connections:r,allowed_updates:o})}getWebhookInfo(){return this.post("/getWebhookInfo")}sendDocument(e,t,r){const o=new(require("form-data"));return o.append("chat_id",String(e)),r&&o.append("caption",r),o.append("document",t.data,{filename:t.filename,contentType:t.type}),this.post("/sendDocument",o,{headers:o.getHeaders()})}sendChatAction(e,t){return this.post("/sendChatAction",{chat_id:e,action:t})}sendInvoice(e,t,r,o,i={}){const n=Object.assign({chat_id:e,provider_token:t,start_parameter:o,need_name:!0,need_phone_number:!0,need_email:!0},r,i);return this.post("/sendInvoice",n)}answerPreCheckoutQuery(e,t){const r={pre_checkout_query_id:e,ok:!0};return t&&(r.ok=!1,r.message=t),this.post("/answerPreCheckoutQuery",r)}getChat(e){const t={chat_id:e};return this.post("/getChat",t)}exportChatInviteLink(e){const t={chat_id:e};return this.post("/exportChatInviteLink",t)}post(e,t,r){return i.retry(()=>this.httpPost(e,t,r)).then(e=>e.data?{ok:e.data.ok?1:0,result:e.data.result}:{ok:0,errcode:400,message:"not a json response"},e=>({ok:0,errcode:e.errno,message:e.message}))}}class Telegram extends BotService{constructor(){super(...arguments),this.client=new TelegramClient(this.settings.TELEGRAM_BOT_SECRET_KEY)}setupWebhook(e){return this.client.getWebhookInfo().then(t=>t.ok&&t.result.url.startsWith(e)?(this.logger.info({url:t.result.url},"Telegram webhook is up to date"),t):(this.logger.info({url:e},"Updating Telegram Webhook url"),this.client.setWebhook(e).then(t=>(this.logger.info({result:t},`Telegram webhook updated to: ${e}`),t)))).catch(e=>{throw this.logger.error(e),new i.Exception(e,"Unable to update Telegram webhook url")})}getMe(){return this.client.getMe()}sendText(e,t,r){return this.client.sendMessage(e,t,r)}sendInvoice(e,t,r,o){return this.client.sendInvoice(e,t,r,o)}sendCode(e,t,r){return this.client.sendMessage(e,`<code>${t}</code>`,Object.assign({parse_mode:"html"},r))}confirmInvoice(e,t){return this.client.answerPreCheckoutQuery(e,t)}getChat(e){return this.client.getChat(e)}exportChatInviteLink(e){return this.client.exportChatInviteLink(e)}}async function N(e,t){return t().catch(t=>{const r=e.construct(Telegram);return e.logger.error(t,{bot:e.bot.username,path:`${e.path}[${String(e.pathIndex)}]`,identity:e.identity},"BotError"),r.sendCode(e.event.chat.id,`${t.name}: ${t.message}`,{reply_to_message_id:e.message.id}).then(()=>void 0,()=>void 0)})}const L=new WeakSet;async function P(e,t){if(!L.has(e)&&(L.add(e),!e.path)){const t=await e.resolve(BotStateService);if(console.log("msg",e.message),e.message.command){e.logger.info(`[${e.identity.address}] --\x3e CMD ${e.message.text}`);const{command:r,commandArgs:o}=e.message;t.start(r),U(e,o)}else"event/callback"===e.event.type?e.path="/"+e.event.type:"event/checkout"===e.event.type?e.path="/"+e.event.type:"event/payment"===e.event.type?e.path="/"+e.event.type:t.empty()&&t.start("/")}return t()}async function F(e,t){let r=e.identity.profile?e.identity.profile.displayName:"Guest";return e.logger.info(`[${e.identity.address}] --\x3e ${r}: ${e.message.text||`[${e.event.type}]`}`),t()}const M=new WeakMap;class Bot extends i.Resolvable{onCreate(){this.addMiddleware(N),this.addMiddleware(F),this.addMiddleware(P),this.addMiddleware(k),this.addMiddleware(A)}async route(e){let t=M.get(e)||0;return t?(t++,M.set(e,t),new Promise((t,r)=>{setImmediate(()=>{this.middleware.compose(e).then(t,r)})})):(t=1,M.set(e,t),this.middleware.compose(e))}async invoke(e){const t=await this.route(e);if(t instanceof DialogRouteAction)return e.path="",U(e,t.data),this.invoke(e);const r=e.getAgent(BotStateService);return r&&await r.save(),t}addMiddleware(e){this.middleware.push(e)}addDialog(e){this.dialog.add(e,this.handler)}addDialogs(e){for(const t of Object.keys(e))this.addDialog(e[t])}}h([t.singleton(),y("design:type",BotDialogRouter)],Bot.prototype,"dialog",void 0),h([t.singleton(),y("design:type",class BotDialogEventHandler extends BotService{beforeMiddleware(e,t,r){const o=this.makeMiddlewareSignature(r);return this.logger.debug(`(*) ${e.path} => ${e.name}::${r.targetKey.toString()}(${o})`),!0}beforeDialog(e,t,r){const o=this.makeMethodSignature(r),i=e.path+t.name;return this.logger.debug(`BOT ${i} => ${e.name}::${r.targetKey.toString()}(${o})`),!0}makeMiddlewareSignature(e){return e.descriptor&&e.descriptor.value.length>2?"ctx, data, next":"ctx, next"}makeMethodSignature(e){return e.descriptor&&e.descriptor.value.length>1?"ctx, data":"ctx"}})],Bot.prototype,"handler",void 0),h([t.transit(),y("design:type",i.Sequence)],Bot.prototype,"middleware",void 0);class BotEvent{}class TelegramBotEventFactory{static normalizeUpdate(e){const t=e.channelData||e;let r,o,n,s,a,l,d,p,c,u=[];if(t.message)(s=t.message).text?n="message/text":s.voice?n="message/voice":s.photo?n="message/photo":s.document?n="message/document":s.location?n="message/location":s.sticker?n="message/sticker":s.new_chat_participant?(n="event/join_chat",a=s.new_chat_participant):s.left_chat_member?(n="event/left_chat",a=s.left_chat_participant):n=s.new_chat_title?"event/new_chat_title":s.new_chat_photo?"event/new_chat_photo":s.successful_payment?"event/payment":"message";else if(t.callback_query)n="event/callback",c=s=t.callback_query.message,p=t.callback_query.data;else if(t.channel_post)n="event/post",s=t.channel_post;else if(t.edited_message)n="event/edit_message",s=t.edited_message;else if(t.edited_message)n="event/edit_post",s=t.edited_channel_post;else{if(!t.pre_checkout_query)throw new i.Exception(t,"Unknown message type");{const e=t.pre_checkout_query;r=e.id,n="event/checkout";const i=e.from;l={id:i.id,type:"private",name:i.username,displayName:i.last_name?i.first_name+" "+i.last_name:i.first_name,isPrivate:!0,isGroup:!1,isChannel:!1},s=e,p=e.invoice_payload,o=new Date}}if(s){r||(r=s.message_id);const e=s.chat;!l&&e&&(l={id:e.id,type:e.type,name:e.username,displayName:e.title||(e.last_name?e.first_name+" "+e.last_name:e.first_name),isPrivate:"private"===e.type,isGroup:"group"===e.type,isChannel:"channel"===e.type}),a||(a=s.from),p||(p=s.text,u=s.entities),c||(delete(c=Object.assign({},s)).message_id,delete c.chat,delete c.from,delete c.date,delete c.text,delete c.entities),s.edit_date?o=new Date(1e3*s.edit_date):s.date&&(o=new Date(1e3*s.date))}if(a){let e=`${a.first_name}`;a.last_name&&(e+=` ${a.last_name}`),d={id:a.id,name:a.username,firstName:a.first_name,lastName:a.last_name,displayName:e,locale:a.language_code,bot:a.is_bot}}return[r,n,o||new Date,l,d,"telegram",t,void 0,c,p,u]}}class TelegramBotEvent extends BotEvent{constructor(e,t,r,o,i,n,s,a,l,d,p){super(),this.id=e,this.type=t,this.timestamp=r,this.chat=o,this.sender=i,this.provider=n,this.providerData=s,this.message=a,this.data=l,this.text=d,this.textEntities=p}static[t.ClassInitializer](e,t){return Reflect.construct(TelegramBotEvent,TelegramBotEventFactory.normalizeUpdate(t[0]))}}class BotIdentity extends i.Identity{}class BotProfile{}class TelegramBotIdentity extends BotIdentity{constructor(e,t,r,o,i,n){super(),this.id=e,this.address=t,this.timezone=r,this.locale=o,this.user=i,this.profile=n}static[t.ClassInitializer](e){const t=e.getAgentOrThrow(BotProfile),r=e.getAgentOrThrow(BotEvent);let o,n,s,a,l,d;if(o=String(r.chat.id),n="/telegram/bot/"+t.id+"/chat/"+r.chat.id,r.sender){const t=i.CreateHashedObjectId({uid:r.sender.id,providerId:"3fdeba596a7d938a05c38daf"}).toHexString();s=t,a={_id:t,id:r.sender.id,name:r.sender.name,displayName:r.sender.displayName,displayImageURL:""},d=r.sender.locale||e.settings.LOCALE}else d=e.settings.LOCALE;return l=e.settings.TIMEZONE,new TelegramBotIdentity(o,n,l,d,s,a)}}class BotMessage{get id(){throw new i.NotImplementedException("id")}get private(){throw new i.NotImplementedException("private")}get text(){throw new i.NotImplementedException("text")}get command(){throw new i.NotImplementedException("command")}get commandArgs(){throw new i.NotImplementedException("commandArgs")}}function W(e){let t,r=[];if(e.text&&Array.isArray(e.textEntities))for(const o of e.textEntities)if("bot_command"===o.type){t=e.text.slice(o.offset,o.offset+o.length);const i=e.text.slice(o.offset+o.length).trim();r=i?i.split(" "):[]}return[t,r]}class TelegramBotMessage extends BotMessage{constructor(){super();const e=i.GetDomainFromParameters(arguments);if(!e)throw new Error("NotAllowedToCreateTelegramBotEventMessage");const t=e.getAgent(TelegramBotEvent);if(!t)throw new Error("NotAllowedToCreateTelegramBotEventMessageWithoutTelegramBotEvent");Reflect.defineProperty(this,"event",{value:t})}get id(){return this.event.id}get private(){return this.event.chat.isPrivate}get text(){return this.event.text}get command(){const[e,t]=W(this.event);return i.cache(this,"commandArgs",t),i.cache(this,"command",e)}get commandArgs(){const[e,t]=W(this.event);return i.cache(this,"command",e),i.cache(this,"commandArgs",t)}}class TelegramBotContext extends BotContext{constructor(e){super(e),i.Performance.log(this,"init","[[init]]")}sendText(e,t){return this.telegram.sendText(t||this.event.chat.id,e)}sendTextWithAction(e,t,r){return this.telegram.sendText(r||this.event.chat.id,e,{reply_markup:{inline_keyboard:[[{text:"yes",callback_data:"cb123456"}]]}})}replyText(e,t,r){return this.telegram.sendText(r||this.event.chat.id,e,{reply_to_message_id:t||this.message.id})}sendTextWithKeyboard(){}}h([t.singleton(),y("design:type",BotProfile)],TelegramBotContext.prototype,"bot",void 0),h([t.singleton(),y("design:type",TelegramBotIdentity)],TelegramBotContext.prototype,"identity",void 0),h([t.singleton(),y("design:type",TelegramBotEvent)],TelegramBotContext.prototype,"event",void 0),h([t.singleton(),y("design:type",TelegramBotMessage)],TelegramBotContext.prototype,"message",void 0),h([t.singleton(),y("design:type",Telegram)],TelegramBotContext.prototype,"telegram",void 0);class TelegramBot extends Bot{}class TelegramBotProfile extends BotProfile{constructor(e,t,r,o){super(),this.id=e,this.name=t,this.displayName=r,this.displayImageURL=o}static[t.ClassInitializer](e,t){return Reflect.construct(TelegramBotProfile,t)}}exports.TelegramBotController=class TelegramBotController extends WebFoundationController{constructor(){super(...arguments),this.token=this.settings.TELEGRAM_BOT_TOKEN}async setup(e){const t=await e.resolve(Telegram),i=u.Reflector(this.constructor).getAttributes(r.ControllerAttribute)[0];if(!i)throw new Error("not found bot route");const n=o.resolve(e.publicURL||this.settings.PUBLIC_URL,`${i.path}/update/${this.token}`),s=await t.setupWebhook(n);return{bot:await t.getMe(),hook:s}}async update(e){if(!e.params.token)throw new r.ParameterError("Missing bot token for telegram");if(this.token!==e.params.token)throw new r.ParameterError("Invalid bot token");const t=e.settings.TELEGRAM_BOT_ID,o=e.settings.TELEGRAM_BOT_NAME,i=e.settings.TELEGRAM_BOT_DISPLAY_NAME||e.settings.TITLE||e.settings.NAME;return e.json().then(r=>(console.log("UPDATE = ",JSON.stringify(r,null,2)),e.resolve(TelegramBotProfile,[t,o,i]).then(t=>e.resolve(TelegramBotEvent,[r]).then(t=>(console.log("EVENT = ",t),e.resolve(TelegramBotContext).then(e=>this.bot.invoke(e))))))).then(t=>{t&&e.logger.trace("ignore bot response")}).catch(t=>{e.logger.error(t,"Unable to parse telegram request")})}},h([t.singleton(TelegramBot),y("design:type",Bot)],exports.TelegramBotController.prototype,"bot",void 0),h([r.method("GET","/setup"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],exports.TelegramBotController.prototype,"setup",null),h([r.method("POST","/update/:token"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],exports.TelegramBotController.prototype,"update",null),exports.TelegramBotController=h([r.controller("/api/integration/telegram/bot")],exports.TelegramBotController),exports.WechatBotController=class WechatBotController extends WebFoundationController{async checkSender(e,t){const r=[e.query.nonce,e.query.timestamp,e.settings.WECHAT_BOT_SECRET_TOKEN].join(""),o=c.createHash("sha1");o.update(r);const i=o.digest().toString("hex");return console.log("current",i),console.log("giving",e.query.signature),console.log("params",e.params),console.log("query",e.query),console.log("body",await e.text()),"GET"===e.method&&i!==e.query.signature?(e.logger.error("InvalidSignature"),""):t()}async verify(e){return e.query.echostr}async update(e){return`\n<xml>\n  <ToUserName><![CDATA[ostx3t918MejplFTMcWTD1erZkHY]]></ToUserName>\n  <FromUserName><![CDATA[gh_6c8b7f4f2e73]]></FromUserName>\n  <CreateTime>${Date.now()}</CreateTime>\n  <MsgType><![CDATA[text]]></MsgType>\n  <Content><![CDATA[你好]]></Content>\n</xml>`}},h([r.middleware(),y("design:type",Function),y("design:paramtypes",[Object,Function]),y("design:returntype",Promise)],exports.WechatBotController.prototype,"checkSender",null),h([r.method("GET","/update/:token"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],exports.WechatBotController.prototype,"verify",null),h([r.method("POST","/update/:token"),y("design:type",Function),y("design:paramtypes",[Object]),y("design:returntype",Promise)],exports.WechatBotController.prototype,"update",null),exports.WechatBotController=h([r.controller("/api/integration/wechat/bot")],exports.WechatBotController);class IdentityBuffer{static get schema(){const e=g.Root.fromJSON({nested:{WebProfile:{fields:{_id:{type:"string",id:1,rule:"optional"},id:{type:"string",id:2,rule:"optional"},username:{type:"string",id:3,rule:"optional"},displayName:{type:"string",id:4},displayImageURL:{type:"string",id:5}}},WebRequestIdentity:{fields:{timezone:{type:"string",id:1},locale:{type:"string",id:2},currency:{type:"string",id:3},theme:{type:"string",id:4,rule:"optional"},account:{type:"string",id:5,rule:"optional"},session:{type:"string",id:6,rule:"optional"},token:{type:"string",id:7,rule:"optional"},expires:{type:"int32",id:8,rule:"optional"},roles:{type:"string",rule:"repeated",id:10},groups:{type:"string",rule:"repeated",id:11},profile:{type:"WebProfile",id:12,rule:"optional"}}}}}).lookupType("WebRequestIdentity");return i.cache(this,"schema",e)}static encode(e){return this.schema.encode(e).finish()}static decode(e,t={}){let r;try{r=this.schema.decode(e).toJSON()}catch(e){return}return Object.assign(t,r)}}IdentityBuffer.IdentityFields=["timezone","locale","currency","theme","account","session","token","expires","user","roles","groups"],IdentityBuffer.ProfileFields=["_id","id","username","displayName","displayImageURL"];class WebFoundationRequestIdentityService extends r.WebRequestIdentityService{deserialize(e,t){return IdentityBuffer.decode(t)}serialize(e,t){return Buffer.from(IdentityBuffer.encode(t))}}class BotStateModel{}h([n.property(),y("design:type",Array)],BotStateModel.prototype,"stack",void 0),h([n.property(),y("design:type",Object)],BotStateModel.prototype,"state",void 0),exports.BotStateCollection=class BotStateCollection extends n.RecordCollection{constructor(){super(BotStateModel)}},exports.BotStateCollection=h([n.collection("state"),y("design:paramtypes",[])],exports.BotStateCollection);class StorageBackedBotStateService extends BotStateService{load(e,t,r){this.id=e,this.model=t,this.history=this.model.stack||[]}static async[t.ClassInitializer](e,t){const r=await e.resolve(exports.BotStateCollection),o={app:e.event.provider,bot:e.bot.id,chat:e.event.chat.id};e.event.sender&&(o.sender=e.event.sender.id);const n=i.CreateHashedObjectId(o);let s=await r.getOne(n);if(s||(s=await r.insertOne(n,Object.assign({},o,{stack:[],state:{}}))),!s)throw new Error("UnableCreateState");return i.cache(e,"state",s.state),new StorageBackedBotStateService(n,s,e)}async save(){return(await this.resolve(exports.BotStateCollection)).updateOne(this.id,{stack:this.history,state:this.domain.state}).then(e=>{e||this.logger.error({dialog:this.id},"Unable to save dialog state")})}}exports.Bot=Bot,exports.BotContext=BotContext,exports.BotEvent=BotEvent,exports.BotIdentity=BotIdentity,exports.BotMessage=BotMessage,exports.BotSettings=class BotSettings extends i.Settings{},exports.BotStateModel=BotStateModel,exports.BotStateService=BotStateService,exports.DialogAttribute=DialogAttribute,exports.ExternalFetcher=ExternalFetcher,exports.ExternalProviderService=ExternalProviderService,exports.ExternalUserService=ExternalUserService,exports.SessionService=SessionService,exports.StorageBackedBotStateService=StorageBackedBotStateService,exports.Telegram=Telegram,exports.TelegramBot=TelegramBot,exports.TelegramBotContext=TelegramBotContext,exports.TelegramBotEvent=TelegramBotEvent,exports.TelegramBotIdentity=TelegramBotIdentity,exports.TelegramBotMessage=TelegramBotMessage,exports.WebFileService=WebFileService,exports.WebFoundationApplication=class WebFoundationApplication extends r.WebApplication{onAfterInit(){this.setType(r.WebRequestIdentityService,WebFoundationRequestIdentityService),this.addController(exports.BitBucketOpenIdAuthController),this.addController(exports.MicrosoftOpenIdAuthController),this.addController(exports.GitHubOpenIdAuthController),this.addController(exports.GitLabOpenIdAuthController),this.addController(exports.GoogleOpenIdAuthController),this.addController(exports.WeiboOpenIdAuthController),this.addController(exports.WebFileController),this.addController(exports.TelegramBotController),this.addController(exports.WechatBotController),this.onInitApplication&&Reflect.apply(this.onInitApplication,this,arguments)}},exports.WebFoundationService=WebFoundationService,exports.WebFoundationSettings=class WebFoundationSettings extends r.WebApplicationSettings{constructor(){super(...arguments),this.API_ROOT="/api",this.WEB_DEVICE_COOKIE_KEY="x",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="y",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e5,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/",this.TRUSTED_EMAIL_PROVIDERS=[],this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[]}},exports.dialog=function(e){return u.decorateClassMethod(new DialogAttribute(e||""))};
//# sourceMappingURL=index.js.map
